$ErrorActionPreference = "Stop"
$PSNativeCommandUseErrorActionPreference = $true
Set-StrictMode -Version Latest

if ($PSEdition -eq "Core" -and $IsWindows -ne $true) {
    Write-Host "This script is only supported on Windows"
    Exit 1
}
elseif ([System.Environment]::OSVersion.Version.Major -lt 10) {
    Write-Host "This script is only supported on Windows 10 or later"
    Exit 2
}

$srv = Get-Service -Name "SCardSvr" -ErrorAction Ignore

if ($srv.Status -ne "Running") {
    Write-Host "Smart Card Service is not running" -ForegroundColor RED
}

$edition = "x86"

if ($env:PROCESSOR_ARCHITECTURE -eq "ARM64") {
    $edition = "arm64"
}

$env:FWUPD_MSS = 255
# $env:DRIVER_NAME = "ESTKme-RED"
$fwupd = "$PSScriptRoot\bin\fwupd-$edition.exe"

if (-not (Test-Path $fwupd)) {
    Write-Host "fwupd not found at $fwupd"
    Exit 4
}

if (Test-Path "$PSScriptRoot\estkme.oem.bin") {
    & $fwupd "oem"
}

& $fwupd "fw"
